Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.tools.ant.taskdefs.optional.pvcs
Class Pvcs

    java.lang.Object
      org.apache.tools.ant.ProjectComponent
          org.apache.tools.ant.Task
              org.apache.tools.ant.taskdefs.optional.pvcs.Pvcs

public class Pvcs
extends Task

Extracts the latest edition of the source code from a PVCS repository. PVCS is a version control system developed by Merant.
Before using this tag, the user running ant must have access to the commands of PVCS (get and pcli) and must have access to the repository. Note that the way to specify the repository is platform dependent so use property to specify location of repository.
This version has been tested agains PVCS version 6.5 and 6.6 under Windows and Solaris. 19-04-2001

The task now has a more robust parser. It allows for platform independant file paths and supports file names with (). Thanks to Erik Husby for bringing the bug to my attention. 27-04-2001

UNC paths are now handled properly. Fix provided by Don Jeffery. He also added an UpdateOnly flag that, when true, conditions the PVCS get using the -U option to only update those files that have a modification time (in PVCS) that is newer than the existing workfile.

Author:
  Thomas Christensen, Don Jeffery, Steven E. Newton

Field Summary

Fields inherited from class org.apache.tools.ant.Task
`description, location, target, taskName, taskType, wrapper`

Fields inherited from class org.apache.tools.ant.ProjectComponent
`project`

Constructor Summary
`Pvcs()` Creates a Pvcs object

Method Summary
`void` | `addPvcsproject(PvcsProject p)` Specify a project within the PVCS repository to extract files from.
`void` | `execute()` Called by the project to let the task do its work.
`java.lang.String` | `getFilenameFormat()` The filenameFormat attribute defines a MessageFormat string used to parse the output of the pcli command.
`java.lang.String` | `getForce()` Get value of force
`boolean` | `getIgnoreReturnCode()` Get value of ignorereturncode
`java.lang.String` | `getLabel()` Get value of label
`java.lang.String` | `getLineStart()` The lineStart attribute is used to parse the output of the pcli command.
`java.lang.String` | `getPromotiongroup()` Get value of promotiongroup
`java.lang.String` | `getPvcsbin()` Get name of the PVCS bin directory
`java.lang.String` | `getPvcsproject()` Get name of the project in the PVCS repository
`java.util.Vector` | `getPvcsprojects()` Get name of the project in the PVCS repository
`java.lang.String` | `getRepository()` Get network name of the PVCS repository
`boolean` | `getUpdateOnly()`
`java.lang.String` | `getUserId()`
`java.lang.String` | `getWorkspace()` Get name of the workspace to store the retrieved files
`protected int` | `runCmd(Commandline cmd, ExecuteStreamHandler out)`
`void` | `setFilenameFormat(java.lang.String f)` The format of the folder names; optional.
`void` | `setForce(java.lang.String f)` Specifies the value of the force argument; optional.
`void` | `setIgnoreReturnCode(boolean b)` If set to true the return value from executing the pvcs commands are ignored; optional, default false.
`void` | `setLabel(java.lang.String l)` Only files marked with this label are extracted; optional.
`void` | `setLineStart(java.lang.String l)` What a valid return value from PVCS looks like when it describes a file.
`void` | `setPromotiongroup(java.lang.String w)` Specifies the name of the promotiongroup argument
`void` | `setPvcsbin(java.lang.String bin)` Specifies the location of the PVCS bin directory; optional if on the PATH.
`void` | `setPvcsproject(java.lang.String prj)` The project within the PVCS repository to extract files from; optional, default "/"
`void` | `setRepository(java.lang.String repo)` The network name of the PVCS repository; required.
`void` | `setUpdateOnly(boolean l)` If set to true files are fetched only if newer than existing local files; optional, default false.
`void` | `setUserId(java.lang.String u)` User ID; unused.
`void` | `setWorkspace(java.lang.String ws)` Workspace to use; optional.

Methods inherited from class org.apache.tools.ant.Task
`getDescription, getLocation, getOwningTarget, getRuntimeConfigurableWrapper, getTaskName, handleErrorFlush, handleErrorOutput, handleFlush, handleOutput, init, isInvalid, log, log, maybeConfigure, perform, setDescription, setLocation, setOwningTarget, setRuntimeConfigurableWrapper, setTaskName`

Methods inherited from class org.apache.tools.ant.ProjectComponent
`getProject, setProject`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### Pvcs

    public Pvcs()

  Creates a Pvcs object

Method Detail

### runCmd

    protected int runCmd(Commandline cmd,
                         ExecuteStreamHandler out)

### execute

    public void execute()
                 throws BuildException

  Description copied from class: `Task`
  Called by the project to let the task do its work. This method may be called more than once, if the task is invoked more than once. For example, if target1 and target2 both depend on target3, then running "ant target1 target2" will run all tasks in target3 twice.

  Overrides:
    `execute` in class `Task`
  Throws:
    `BuildException` - Something is stopping the build...

### getRepository

    public java.lang.String getRepository()

  Get network name of the PVCS repository

  Returns:
    String

### getFilenameFormat

    public java.lang.String getFilenameFormat()

  The filenameFormat attribute defines a MessageFormat string used to parse the output of the pcli command. It defaults to `{0}-arc({1})`. Repositories where the archive extension is not -arc should set this.

### setFilenameFormat

    public void setFilenameFormat(java.lang.String f)

  The format of the folder names; optional. This must be in a format suitable for `java.text.MessageFormat`. Index 1 of the format will be used as the file name. Defaults to `{0}-arc({1})`

### getLineStart

    public java.lang.String getLineStart()

  The lineStart attribute is used to parse the output of the pcli command. It defaults to `"P:`. The parser already knows about / and \\, this property is useful in cases where the repository is accessed on a Windows platform via a drive letter mapping.

### setLineStart

    public void setLineStart(java.lang.String l)

  What a valid return value from PVCS looks like when it describes a file. Defaults to `"P:`. If you are not using an UNC name for your repository and the drive letter `P` is incorrect for your setup, you may need to change this value, UNC names will always be accepted.

### setRepository

    public void setRepository(java.lang.String repo)

  The network name of the PVCS repository; required.

  Parameters:
    `repo` - String

### getPvcsproject

    public java.lang.String getPvcsproject()

  Get name of the project in the PVCS repository

  Returns:
    String

### setPvcsproject

    public void setPvcsproject(java.lang.String prj)

  The project within the PVCS repository to extract files from; optional, default "/"

  Parameters:
    `prj` - String

### getPvcsprojects

    public java.util.Vector getPvcsprojects()

  Get name of the project in the PVCS repository

  Returns:
    Vector

### getWorkspace

    public java.lang.String getWorkspace()

  Get name of the workspace to store the retrieved files

  Returns:
    String

### setWorkspace

    public void setWorkspace(java.lang.String ws)

  Workspace to use; optional. By specifying a workspace, the files are extracted to that location. A PVCS workspace is a name for a location of the workfiles and isn't as such the location itself. You define the location for a workspace using the PVCS GUI clients. If this isn't specified the default workspace for the current user is used.

  Parameters:
    `ws` - String

### getPvcsbin

    public java.lang.String getPvcsbin()

  Get name of the PVCS bin directory

  Returns:
    String

### setPvcsbin

    public void setPvcsbin(java.lang.String bin)

  Specifies the location of the PVCS bin directory; optional if on the PATH. On some systems the PVCS executables pcli and get are not found in the PATH. In such cases this attribute should be set to the bin directory of the PVCS installation containing the executables mentioned before. If this attribute isn't specified the tag expects the executables to be found using the PATH environment variable.

  To do:
    use a File setter and resolve paths.

### getForce

    public java.lang.String getForce()

  Get value of force

  Returns:
    String

### setForce

    public void setForce(java.lang.String f)

  Specifies the value of the force argument; optional. If set to yes all files that exists and are writable are overwritten. Default no causes the files that are writable to be ignored. This stops the PVCS command get to stop asking questions!

  To do:
    make a boolean setter

### getPromotiongroup

    public java.lang.String getPromotiongroup()

  Get value of promotiongroup

  Returns:
    String

### setPromotiongroup

    public void setPromotiongroup(java.lang.String w)

  Specifies the name of the promotiongroup argument

### getLabel

    public java.lang.String getLabel()

  Get value of label

  Returns:
    String

### setLabel

    public void setLabel(java.lang.String l)

  Only files marked with this label are extracted; optional.

### getIgnoreReturnCode

    public boolean getIgnoreReturnCode()

  Get value of ignorereturncode

  Returns:
    String

### setIgnoreReturnCode

    public void setIgnoreReturnCode(boolean b)

  If set to true the return value from executing the pvcs commands are ignored; optional, default false.

### addPvcsproject

    public void addPvcsproject(PvcsProject p)

  Specify a project within the PVCS repository to extract files from.

### getUpdateOnly

    public boolean getUpdateOnly()

### setUpdateOnly

    public void setUpdateOnly(boolean l)

  If set to true files are fetched only if newer than existing local files; optional, default false.

### getUserId

    public java.lang.String getUserId()

### setUserId

    public void setUserId(java.lang.String u)

  User ID; unused.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000-2003 Apache Software Foundation. All Rights Reserved.